#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

void setpage()
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov al, 013h;
asm mov ah, 0;
asm int 10h;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void retpage()
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov al, 03h;
asm mov ah, 0;
asm int 10h;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotxyc(int xint, int yint, int cint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov ax, cint;
asm mov ah, 0ch;
asm mov cx, xint;
asm mov dx, yint;
asm int 10h;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void spritedef()
{
asm GunDef DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,014,000,000;
asm DB 000,000,014,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,014,000,000;
asm DB 000,014,000,014,000;
asm DB 000,014,014,014,000;

asm BulDef DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,014,000,000;
asm DB 000,000,014,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;

asm ObjDef DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,015,015,015,000;
asm DB 000,000,000,000,000;
asm DB 000,015,015,015,000;
asm DB 000,000,000,000,000;

asm ExpDef DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,013,013,013,000;
asm DB 000,000,000,000,000;
asm DB 000,014,014,014,000;
asm DB 000,000,000,000,000;

asm LivDef DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,012,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,014,000,000;
asm DB 000,000,014,000,000;
asm DB 000,000,014,000,000;
asm DB 000,000,000,000,000;

asm BlkDef DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
asm DB 000,000,000,000,000;
}

void plotspriteGun(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG GunDef;
asm mov ds, ax;
asm mov ax, OFFSET GunDef;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatGunDef:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatGunDef;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatGunDef;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotspriteBul(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG BulDef;
asm mov ds, ax;
asm mov ax, OFFSET BulDef;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatGunDef:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatGunDef;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatGunDef;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotspriteExp(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG ExpDef;
asm mov ds, ax;
asm mov ax, OFFSET ExpDef;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatExpDef:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatExpDef;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatExpDef;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotspriteObj(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG ObjDef;
asm mov ds, ax;
asm mov ax, OFFSET ObjDef;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatObjDef:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatObjDef;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatObjDef;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotspriteLiv(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG LivDef;
asm mov ds, ax;
asm mov ax, OFFSET LivDef;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatLivDef:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatLivDef;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatLivDef;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

void plotspriteBlk(int xint, int yint)
{
asm push ax;
asm push bx;
asm push cx;
asm push dx;
asm push ds;
asm push si;
asm push es;
asm push di;
asm mov cx, xint;
asm mov dx, yint;
asm mov ax, SEG BlkDef;
asm mov ds, ax;
asm mov ax, OFFSET BlkDef;
asm mov si, ax;
asm mov bl, byte ptr 0;
asm mov bh, byte ptr 0;
repeatBlkDef:;
asm mov al, byte ptr ds:[si];
asm mov ah, 0ch;
asm int 10h;
asm inc si;
asm inc cx;
asm inc bl;
asm cmp bl, byte ptr 5;
asm jl repeatBlkDef;
asm mov bl, byte ptr 0;
asm inc bh;
asm clc;
asm sbb cx, word ptr 5;
asm inc dx;
asm cmp bh, byte ptr 8;
asm jl repeatBlkDef;
asm pop di;
asm pop es;
asm pop si;
asm pop ds;
asm pop dx;
asm pop cx;
asm pop bx;
asm pop ax;
}

int main()
{
int xpos, ypos, ipos;
int Bulxpos, Bulypos, Bulipos;
int Objxpos, Objypos, Objipos, ObjxD, ObjyD;

int Livxpos, Livypos, Livipos;
int Lives, MaxLives, Work;

int setBul;

char keypress;

unsigned long delay;

int frqHertz;

keypress = '';

ipos = 1;
xpos = 155;
ypos = 180;

setBul = 0;

Bulipos = 1;
Bulxpos = 155;
Bulypos = 180;

Objipos = 1;
Objxpos = 155;
Objypos = 12;
ObjxD = 1;
ObjyD = 2;

Livipos = 1;
Livxpos = 1;
Livypos = 190;

Lives = 24;
MaxLives = 53;

system("cls");
printf("\n Thank you Jesus Christ.");
printf("\n Honours to my real mom:  Huong Thi Vu");
printf("\n Honours to my real dad:  Nguyen Binh Thuy");
printf("\n Bless my real mom too.");
printf("\n ");
printf("\n Created using Turbo C, Copyright (C) Borland 1987, 1988.");
printf("\n ");
printf("\n Please press a key to continue.  Thx.");
getch();

setpage();

for(Work = 0; Work < Lives; Work = Work + 1)
{
plotspriteLiv(Livxpos+(Work*6), Livypos);
}

looper:;

for(delay = 0; delay < 12000; delay++)
{
asm nop;
}

plotspriteGun(xpos, ypos);

if( kbhit() )
{
keypress = getch();

if (keypress == 'a')
{
if( xpos > 0 )
{
xpos = xpos - ipos;
}
}

if (keypress == 'd')
{
if( xpos < 320 )
{
xpos = xpos + ipos;
}
}

if(keypress == 'q')
{
goto exitroutine;
}

if  (keypress == 'f')
{
keypress = '';
if( setBul == 0 )
{
Lives = Lives - 1;
plotspriteBlk(Livxpos + (6*Lives), Livypos);
if(Lives < 0)
{
goto exitroutine;
}
setBul = 1;
}
}

}

if( setBul == 1 )
{
setBul = 2;
Bulxpos = xpos;
Bulypos = ypos;
Bulipos = ipos;
}

if( setBul == 2 )
{
if( Bulypos > 1 )
{
Bulypos = Bulypos - Bulipos;
plotspriteBul(Bulxpos, Bulypos);
}
else
{
setBul = 0;
}

}

if(   ObjxD == 0)
{
if(Objxpos > 0)
{
Objxpos = Objxpos - Objipos;
}
else
{
ObjxD = 1;
}
}

if(ObjxD == 1   )
{
if(Objxpos < 320)
{
Objxpos = Objxpos + Objipos;
}
else
{
ObjxD = 0;
}
}

if((((Objxpos-5)<(Bulxpos))&&((Bulxpos)<(Objxpos+5)))&&(((Objypos-5)<(Bulypos))&&((Bulypos)<(Objypos+5))))
{
plotspriteExp(Objxpos, Objypos);
for(delay = 0; delay < 100000; delay++);
plotspriteLiv(Livxpos + (6*Lives), Livypos);
Lives = Lives + 1;
if(Lives == MaxLives)
{
goto YouWin;
}
}
else
{
plotspriteObj(Objxpos, Objypos);
}


goto looper;

YouWin:;
retpage();
printf("\n You Win.");
getch();
printf("\n JESUS CHRIST; MY THE LORD OF ALL HOSTS!");
getch();
printf("\n DAD: NGUYEN BINH THUY");
printf("\n MOM: HUONG THI VU");
printf("\n COUSIN, CARL, ANH CUONG CAO VU");
getch();
printf("\n    ADJQ");
getch();

printf("\n JESUS CHRIST!..MY THE LORD OF ALL HOSTS.");
printf("\n ARROW KEYS.  HJL SPACE.  Q QUIT.  ASDWG.");
printf("\n DAD NGUYEN BINH THUY");
printf("\n MOM HUONG THI VU:");
printf("\n XIN CAM ON CHUA DA CHO TOAN THE GIA DINH");
printf("\n  CON TOT DEP.  VA XIN CHUA CAM CHO CON");
printf("\n  CUA CON BINH THAN LAI.");
printf("\n   CON XIN CHUA VA DUC ME.");
printf("\n  CON CUA CON LA NGUYEN KHOA TIEN!");
printf("\n SISTER NGUYEN KHOA THI, AND THUYEN");
getch();

printf("\n COUSIN CARL ANH CUONG CAO VU");
printf("\n JEANNIE VU");
printf("\n STEVEN VU");
printf("\n TIDO VU");
printf("\n JACKIE VU");
printf("\n AMANDA VU");
printf("\n ASHLEY VU");
printf("\n ALEX VU");
printf("\n CORY VU");
printf("\n JAN VU");
printf("\n ALLISON VU");
printf("\n LAURA VU");
printf("\n ALANIS VU");
printf("\n ALENA VU");
printf("\n NINA TRAN");
printf("\n BAC HUYNH");
printf("\n CO TIEN");
printf("\n GRANDMA");
printf("\n SOPHIA THUY VU");
printf("\n DOCTOR CAU THAO");
printf("\n CAU TRIEM");
printf("\n THAO");
printf("\n CHI HOA");
printf("\n CHI LAN");
printf("\n CAU TRUOC");
printf("\n CINDY VU");
printf("\n THERESA VU");
printf("\n JENNIFER VU");
printf("\n JOHN VU");
printf("\n JAMES VU");
printf("\n QUADKO");
printf("\n DAVID BRACKEEN");
printf("\n JVS");
printf("\n MRFLIBBLE");
printf("\n PSEUDOCODER");
printf("\n DANIEL COOK");
printf("\n JOHN CARMACK");
printf("\n ALLEN PILGRIM AND SON");
printf("\n DOSGUY");
printf("\n LUNICK");
printf("\n MIKE");
printf("\n AL");
printf("\n MANNY");
printf("\n WALMART");
printf("\n KROGER");
printf("\n FIESTA");
printf("\n NIEMEN MARCUS");
printf("\n ART LINCH");
printf("\n CHAD JON");
printf("\n TOM TAYLOR");
printf("\n PEGGY");
printf("\n DENISE");
getch();
printf("\n WWW.DONOHOS.COM");
printf("\n WWW.DOSGAMES.COM");
printf("\n WWW.CLASSICDOSGAMES.COM");
printf("\n WWW.PLAYDOSGAMES.COM");
printf("\n WWW.ARTENSOFT.COM");
printf("\n RFOBASIC.FREEFORUMS.ORG");
getch();
printf("\n USPS.COM");
printf("\n TUTORIALSPOINT.COM");
printf("\n TARGET");
printf("\n PROGRAMMERSHEAVEN.COM");
printf("\n WWW.CHESS.COM");
getch();
printf("\n WWW.CHESSFORUMS.ORG");
printf("\n WWW.PELLESC.COM");
printf("\n XFINITY.COM");
printf("\n RELIANT.COM");
printf("\n OFFICEDEPOT.COM");
getch();
printf("\n COMCAST IVAN");
getch();
printf("\n PAPPADEAUX SEAFOOD PLACE");
printf("\n HOLLISTER AND NW FWY");
printf("\n HOUSTON TEXAS");
getch();
printf("\n MEL AND HALLFIRY");
getch();
printf("\n CHRISTY FROM TOSHIBA");
printf("\n SOUMYA B FROM ADOBE");
printf("\n MICROSOFT");
printf("\n RICHARD AND NICK AT GOODMAN");
printf("\n HONDA");
printf("\n MAZDA");
printf("\n BMW");
printf("\n MERCEDES");
getch();
printf("\n HOLLYWOOD");
getch();
printf("\n SOCIAL SECURITY");
getch();
printf("\n PIXELTHING");
getch();
printf("\n DAVID NGUYEN FROM FOXCONN");
printf("\n MARY CREWS AT WELLSFARGO");
getch();
printf("\n SHELLY AT MANPOWER HOUSTON TX");
getch();
printf("\n ALL THE BABES AND COOL DUDES");
getch();
printf("\n BE HAPPY ALL THE TIME NOW.");
getch();
printf("\n IBM");
printf("\n INTEL");
printf("\n USA");
printf("\n VIETNAM");
printf("\n AND SUCH HEHE");
getch();
printf("\n NVIDIA");
printf("\n AMD");
printf("\n ATI");
getch();
printf("\n TOM HARDWARE");
printf("\n DENIWEB");
printf("\n ST.JUDE");
getch();
printf("\n MORE HOPEFULLY...EVERYONE");
printf("\n WWW.VETUSWARE.ORG");
getch();
printf("\n IM SORRY FOR HALLOWEEN");
printf("\n THANK YOU ALL!");
getch();
return(0);

YouLose:;
retpage();
printf("\n We will see you next life!");
getch();
return(0);

exitroutine:;
retpage();
return(0);
}
